#region usings
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "dictionary", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValuedictionaryNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("ID In")]
		public ISpread<int> FIDIn;

		[Input("Value In")]
		public ISpread<ISpread<double>> FValueIn;

		[Input("Reset", IsSingle = true, IsBang = true)]
		public ISpread<bool> FReset;

		[Output("ID Out")]
		public ISpread<int> FIDOut;

		[Output("Value Out ")]
		public ISpread<ISpread<double>> FValueOut;


		[Import()]
		public ILogger FLogger;
		#endregion fields & pins


		Dictionary<int, ISpread<double>> IdValue = new Dictionary<int, ISpread<double>>();

		public void Evaluate(int SpreadMax)
		{
			if (FIDIn.SliceCount > 0 && FValueIn.SliceCount > 0) {
				for (int i = 0; i < FIDIn.SliceCount; i++) {
					int id = FIDIn[i];
					IdValue[id] = FValueIn[i].Clone();
				}

				if (FReset[0])
					IdValue.Clear();

				FIDOut.SliceCount = IdValue.Count;
				FValueOut.SliceCount = IdValue.Count;
				int j = 0;
				foreach (KeyValuePair<int, ISpread<double>> kvp in IdValue) {
					FIDOut[j] = kvp.Key;
					FValueOut[j] = kvp.Value;
					j++;
				}


			}


		}
	}
}
